Index: branches/bsp_model/src/lib/collision_reaction/collision.h
===================================================================
--- branches/bsp_model/src/lib/collision_reaction/collision.h	(revision 8202)
+++ branches/bsp_model/src/lib/collision_reaction/collision.h	(revision 8203)
@@ -43,4 +43,5 @@
     inline void setEntityBCollide(bool flag) { this->entityACollide = flag; }
 
+
     /** @returns true if this Collision has already been dispatched */
     inline bool isDispatched() { return this->bDispatched; }
Index: branches/bsp_model/src/lib/collision_reaction/collision_event.h
===================================================================
--- branches/bsp_model/src/lib/collision_reaction/collision_event.h	(revision 8202)
+++ branches/bsp_model/src/lib/collision_reaction/collision_event.h	(revision 8203)
@@ -38,4 +38,8 @@
   inline BoundingVolume* getBVB() const { return this->bvB; }
 
+  /** @return ground plane if collided with bsp model */
+  inline Plane* getGroundPlane() { return this->ground; }
+
+
 
   inline void operator()(WorldEntity* entityA, WorldEntity* entityB, BoundingVolume* bvA, BoundingVolume* bvB) { this->collide(entityA, entityB, bvA, bvB); }
Index: branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc
===================================================================
--- branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8202)
+++ branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8203)
@@ -33,5 +33,5 @@
   : CollisionReaction()
 {
-  this->setClassID(CL_CR_OBJECT_DAMAGE, "CRPhysicsGroundWalk");
+  this->setClassID(CL_CR_PHYSICS_GROUND_WALK, "CRPhysicsGroundWalk");
 
 }
@@ -52,5 +52,5 @@
 void CRPhysicsGroundWalk::reactToCollision(Collision* collision)
 {
-
+//   Vector normal = collision
 
 
Index: branches/bsp_model/src/lib/graphics/importer/bsp_file.cc
===================================================================
--- branches/bsp_model/src/lib/graphics/importer/bsp_file.cc	(revision 8202)
+++ branches/bsp_model/src/lib/graphics/importer/bsp_file.cc	(revision 8203)
@@ -392,5 +392,5 @@
   ::std::string absFileName;
    char* baseName = "/worlds/bsp";
-  
+
   char fileName [500];
   char ext [500];
@@ -406,5 +406,5 @@
     if(strlen(fileName) == 0)
     {
-     
+
      //         Default Material
     this->Materials[i].mat = new Material();
@@ -428,5 +428,5 @@
     strcpy(ext, ".mov");
     strncat (fileName, ext, strlen(fileName) );
-    
+
     PRINTF(0)("BSP FILE: Name %s . \n", fileName);
 
@@ -631,5 +631,7 @@
   sc =  ((unsigned char *)(&lightMapTexture))[i];
   sc *= 1/255.0;
-  scale = 1.0;
+
+  scale = 1.8; // Adjust brightness here
+
   if(sc > 1.0f && (temp = (1.0f/sc)) < scale) scale=temp;
   scale*=255.0;
Index: branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc
===================================================================
--- branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc	(revision 8202)
+++ branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc	(revision 8203)
@@ -1,19 +1,19 @@
 /*
    orxonox - the future of 3D-vertical-scrollers
- 
+
    Copyright (C) 2006 orx
- 
+
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2, or (at your option)
    any later version.
- 
+
    ### File Specific:
    main-programmer: bottac@ee.ethz.ch
- 
+
    Inspired by:
    Rendering Q3 Maps by Morgan McGuire                  http://graphics.cs.brown.edu/games/quake/quake3.html
    Unofficial Quake 3 Map Specs by Kekoa Proudfoot      http://graphics.stanford.edu/~kekoa/q3/
- 
+
    Collision detection adapted from:
    Quake 3 Collision Detection by Nathan Ostgard        http://www.devmaster.net/articles/quake3collision/
@@ -67,9 +67,9 @@
 BspManager::BspManager(const TiXmlElement* root)
 {
- 
- 
+
+
   if( root != NULL)
     this->loadParams(root);
- 
+
   CDEngine::getInstance()->setBSPModel(this);
 } */
@@ -99,5 +99,5 @@
   this->root  = this->bspFile->get_root();
   this->alreadyVisible = new bool [this->bspFile->numFaces];
- 
+
   CDEngine::getInstance()->setBSPModel(this);
 }
@@ -106,5 +106,5 @@
 const void BspManager::tick(float time)
 {
-  
+
 }
 const void BspManager::draw()
@@ -126,7 +126,7 @@
   this->drawDebugCube(&this->out1);
   this->drawDebugCube(&this->out2);
-  
+
   */
-  
+
 
   // Draw Debug Terrain
@@ -165,13 +165,13 @@
 
 
- 
+
  // this->checkCollision(this->root, &this->cam);   //!< Test Collision Detection
-  
-  
+
+
   this->outputStartsOut = true;
   this->outputAllSolid = false;
   this->outputFraction = 1.0f;
   this->checkCollision(State::getPlayer()->getPlayable());
-  
+
 
   if ( viscluster < 0  || ((int *)(this->bspFile->header))[35] == 0 )  //!< if (sizeof(Visdata) == 0)
@@ -188,5 +188,5 @@
 
       /** Do Frustum culling and draw 'em all **/
-     
+
       Vector dir = State::getCameraNode()->getAbsDirX();
 
@@ -829,5 +829,5 @@
 void BspManager::checkCollisionBox(void)
 {
-  
+
 };
 
@@ -873,4 +873,13 @@
   dest.z  += forwardDir.z;
   Vector out = dest;
+
+
+
+
+
+
+
+
+
   if(!worldEntity->isA(CL_PLAYABLE)) {
 
@@ -879,4 +888,5 @@
   }
   else {
+
     bool collision = false;
     Vector position1 = position + Vector(0.0,0.1,0.0);
@@ -928,6 +938,7 @@
 
     // Return the normal here: Normal's stored in this->collPlane;
-    
+
     if(collision) worldEntity->collidesWithGround(out,out1,out2);
+//     registerCollision(WorldEntity* entity, Vector(this->collPlane.x, ), Vector position);
 
   }