Index: /data/trunk/AUTHORS
===================================================================
--- /data/trunk/AUTHORS	(revision 8208)
+++ /data/trunk/AUTHORS	(revision 8209)
@@ -32,13 +32,13 @@
 audio/ambient/eightbit/Mars.ogg                             Erik Skiff- Underclocked (Resistor Anthems), License: CC by 3.0 US
 audio/ambient/eightbit/Nebula_metal.ogg                     Kevin Young - Samples (License: CC Sampling+) from: Sea Fury (Zap2) and Digifishmusic (Infinite Thunder)
-audio/ambient/jazz/AlphaCentauri.ogg                        cdk - Midnight Theme (cdk mix), License: CC by 3.0
-audio/ambient/jazz/Asteroid_rocks.ogg                       KCentric - OxyMoron, License: CC by 3.0
-audio/ambient/jazz/Earth.ogg                                echoed - Window like, License: CC by 3.0
-audio/ambient/jazz/Fight1.ogg                               Damian Frick - Samples (License: CC by 3.0) from: stefsax - Awel
-audio/ambient/jazz/Ganymede.ogg                             cdk - pieces of life, License: CC by 3.0
-audio/ambient/jazz/Jupiter.ogg                              gurdonark - Caper, CC by 3.0
-audio/ambient/jazz/mainmenu.ogg                             Citizen Nyx - Undercover, License: CC by 3.0                       
-audio/ambient/jazz/Mars.ogg                                 shragrugge - Sax, Flute, n Glass, License: CC by 3.0
-audio/ambient/jazz/Nebula_metal.ogg                         Coriolis Effect - Mseq, License: CC by 3.0
+audio/ambient/jazzy/AlphaCentauri.ogg                        cdk - Midnight Theme (cdk mix), License: CC by 3.0
+audio/ambient/jazzy/Asteroid_rocks.ogg                       KCentric - OxyMoron, License: CC by 3.0
+audio/ambient/jazzy/Earth.ogg                                echoed - Window like, License: CC by 3.0
+audio/ambient/jazzy/Fight1.ogg                               Damian Frick - Samples (License: CC by 3.0) from: stefsax - Awel
+audio/ambient/jazzy/Ganymede.ogg                             cdk - pieces of life, License: CC by 3.0
+audio/ambient/jazzy/Jupiter.ogg                              gurdonark - Caper, CC by 3.0
+audio/ambient/jazzy/mainmenu.ogg                             Citizen Nyx - Undercover, License: CC by 3.0                       
+audio/ambient/jazzy/Mars.ogg                                 shragrugge - Sax, Flute, n Glass, License: CC by 3.0
+audio/ambient/jazzy/Nebula_metal.ogg                         Coriolis Effect - Mseq, License: CC by 3.0
 audio/sounds/Button_press1.ogg                              Corsica S - blip10, License: CC Sampling+
 audio/sounds/Button_press2.ogg                              Corsica S - blip11, License: CC Sampling+
Index: /data/trunk/gui/looknfeels/OrxonoxLook.looknfeel
===================================================================
--- /data/trunk/gui/looknfeels/OrxonoxLook.looknfeel	(revision 8208)
+++ /data/trunk/gui/looknfeels/OrxonoxLook.looknfeel	(revision 8209)
@@ -2455,4 +2455,5 @@
 		<PropertyDefinition name="FrameColours" initialValue="tl:FFFFFFFF tr:FFFFFFFF bl:FFFFFFFF br:FFFFFFFF" redrawOnWrite="true" />
 		<PropertyDefinition name="BackgroundColours" initialValue="tl:FFFFFFFF tr:FFFFFFFF bl:FFFFFFFF br:FFFFFFFF" redrawOnWrite="true" />
+		<Property name="TextColours" value="tl:FFFFFFFF tr:FFFFFFFF bl:FFFFFFFF br:FFFFFFFF" redrawOnWrite="true" />
         <Property name="FrameEnabled" value="True" />
         <Property name="BackgroundEnabled" value="True" />
Index: /data/trunk/materials/OrxonoxSky.material
===================================================================
--- /data/trunk/materials/OrxonoxSky.material	(revision 8208)
+++ /data/trunk/materials/OrxonoxSky.material	(revision 8209)
@@ -47,4 +47,22 @@
 			{
 				cubic_texture starbox.jpg separateUV
+				tex_address_mode clamp
+			}
+		}
+	}
+}
+
+material Orxonox/Starbox2
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+
+			texture_unit
+			{
+				cubic_texture SkyboxFile.png separateUV
 				tex_address_mode clamp
 			}
Index: /data/trunk/materials/planets.material
===================================================================
--- /data/trunk/materials/planets.material	(revision 8209)
+++ /data/trunk/materials/planets.material	(revision 8209)
@@ -0,0 +1,126 @@
+material planets/blueplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture blueplanet.png
+			}
+		}
+	}
+}
+
+material planets/brownplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture brownplanet.png
+			}
+		}
+	}
+}
+
+material planets/greenplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture greenplanet.png
+			}
+		}
+	}
+}
+
+material planets/greyplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture greyplanet.png
+			}
+		}
+	}
+}
+
+material planets/redplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture redplanet.png
+			}
+		}
+	}
+}
+
+material planets/violetplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture violetplanet.png
+			}
+		}
+	}
+}
+
+material planets/violetplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture violetplanet.png
+			}
+		}
+	}
+}
+