Index: data/pool/images/effects/AUTHORS
===================================================================
--- data/pool/images/effects/AUTHORS	(revision 8210)
+++ data/pool/images/effects/AUTHORS	(revision 8211)
@@ -2,7 +2,5 @@
 
 File                                         Author
-3arrowsup.png                                Eric Beier and Benedict Simlinger
-arrow.png                                    Damian Frick
-asterix.png                                  Damian Frick
+
 atmosphere.png                               Felix Schulthess
 atmospheretype1.png                          Marian Runo
@@ -17,8 +15,6 @@
 bigflare1.png                                Fabian Landau
 clouds.png                                   Benjamin de Capitani
-cross.png                                    Damian Frick
 explosion3.png                               Fabian Landau
 explosion.png                                unknown
-eye.png                                      Eric Beier and Benedict Simlinger
 flare2_1.png                                 David Gassner
 flare2.png                                   unknown
@@ -34,8 +30,21 @@
 LightningBall_8.png                          Joël Smely
 mapgrid.png                                  Si Sun
+pickup/3arrowsup.png                         Eric Beier and Benedict Simlinger
+pickup/arrow.png                             Damian Frick
+pickup/asterix.png                           Damian Frick
+pickup/cross.png                             Damian Frick
+pickup/eye.png                               Eric Beier and Benedict Simlinger
+shield.png                                   Eric Beier and Benedict Simlinger
+planets/blueplanet.png                       Damian Frick
+planets/brownplanet.png                      Damian Frick
+planets/greenplanet.png                      Damian Frick
+planets/greyplanet.png                       Damian Frick
+planets/redplanet.png                        Damian Frick
+planets/violetplanet2.png                    Damian Frick
+planets/violetplanet.png                     Damian Frick
+primitives/sphere.png                        Damian Frick
 ring_flare2.png                              unknown
 ring_flare.png                               unknown
 Sepia1D.png                                  Fabian Landau?
-shield.png                                   Eric Beier and Benedict Simlinger
 smoke2.png                                   Fabian Landau
 smoke3.png                                   Fabian Landau
Index: data/pool/images/effects/pickup/TODO
===================================================================
--- data/pool/images/effects/pickup/TODO	(revision 8211)
+++ data/pool/images/effects/pickup/TODO	(revision 8211)
@@ -0,0 +1,2 @@
+* Add missing .xcf files.
+* Move everything into one material file?
Index: data/pool/images/effects/pickup/info.xml
===================================================================
--- data/pool/images/effects/pickup/info.xml	(revision 8211)
+++ data/pool/images/effects/pickup/info.xml	(revision 8211)
@@ -0,0 +1,26 @@
+<info>
+    <name>Spacestation parts</name>
+    <author>Mirko Kaiser</author>
+    <dependency>/materials/CuboidSpaceStation.material</dependency>
+    <dependency for="CuboidBody.mesh, CuboidConnBody.mesh, DoubleCuboidBody.mesh, satellitedish.mesh">/images/textures/babel-wall1a.jpg</dependency>
+    <dependency for="CuboidBody.mesh, CuboidConnBody.mesh, DoubleCuboidBody.mesh">/images/textures/babel-wall1b.jpg</dependency>
+    <dependency for="CuboidBody.mesh, CuboidConnBody.mesh, CuboidLandingZone.mesh, DoubleCuboidBody.mesh, satellitedish.mesh, SemiCircleCockpit.mesh, Thruster.mesh">/images/textures/babel-wall6a.jpg</dependency>
+    <dependency for="CuboidBody.mesh, CuboidConnBody.mesh, DoubleCuboidBody.mesh, satellitedish.mesh">/images/textures/babel-wall6b.jpg</dependency>
+    <dependency>/images/textures/babel-trim3b.jpg</dependency>
+    <dependency for="CuboidConnBody.mesh">/images/textures/CuboidConnectionBodyTop.jpg</dependency>
+    <dependency for="CuboidConnBody.mesh">/images/textures/CuboidConnectionBodySide.jpg</dependency>
+    <dependency for="satellitedish.mesh">/images/textures/dish.jpg</dependency>
+    <dependency for="satellitedish.mesh, SemiCircleCockpit.mesh, Thruster.mesh">/images/textures/thrust.jpg</dependency>
+    <dependency for="SemiCircleCockpit.mesh">/images/textures/CockpitNose.jpg</dependency>
+    <dependency for="SemiCircleCockpit.mesh">/images/textures/CockpitSide.png</dependency>
+    <dependency for="SolarPanel.mesh">/images/textures/seamless/sl_panel.jpg</dependency>
+    <screenshot for="CuboidBody.mesh">screenhots/CuboidBody.png</screenshot>
+    <screenshot for="CuboidConnBody.mesh">screenhots/CuboidConnBody.png</screenshot>
+    <screenshot for="CuboidConnection.mesh">screenhots/CuboidConnection.png</screenshot>
+    <screenshot for="CuboidLandingZone.mesh">screenhots/CuboidLandingZone.png</screenshot>
+    <screenshot for="DoubleCuboidBody.mesh">screenhots/DoubleCuboidBody.png</screenshot>
+    <screenshot for="satellitedish.mesh">screenhots/satellitedish.png</screenshot>
+    <screenshot for="SemiCircleCockpit.mesh">screenhots/SemiCircleCockpit.png</screenshot>
+    <screenshot for="SolarPanel.mesh">screenhots/SolarPanel.png</screenshot>
+    <screenshot for="Thruster.mesh">screenhots/Thruster.png</screenshot>
+</info>
Index: data/pool/images/effects/planets/info.xml
===================================================================
--- data/pool/images/effects/planets/info.xml	(revision 8211)
+++ data/pool/images/effects/planets/info.xml	(revision 8211)
@@ -0,0 +1,12 @@
+<info>
+    <name>Pickup billboards</name>
+    <author for="arrow.png, asterix,png, cross.png">Damian Frick</author>
+    <author for="3arrowsup.png, eye.png, shield.png">Eric Beier</author>
+    <author for="3arrowsup.png, eye.png, shield.png">Benedict Simlinger</author>
+    <dependency for="3arrowsup.png">/materials/3arrowsup.material</dependency>
+    <dependency for="arrow.png">/materials/Arrow.material</dependency>
+    <dependency for="asterix,png">/materials/Asterix.material</dependency>
+    <dependency for="cross.png">/materials/Cross.material</dependency>
+    <dependency for="eye.png">/materials/Eye.material</dependency>
+    <dependency for="shield.png">/materials/Shield.material</dependency>
+</info>
Index: data/pool/images/effects/primitives/info.xml
===================================================================
--- data/pool/images/effects/primitives/info.xml	(revision 8211)
+++ data/pool/images/effects/primitives/info.xml	(revision 8211)
@@ -0,0 +1,5 @@
+<info>
+    <name>Billboard primitives</name>
+    <author for="spere.png">Damian Frick</author>
+    <dependency for="sphere.png">/materials/Sphere2.material</dependency>
+</info>
Index: data/pool/materials/planets.material
===================================================================
--- data/pool/materials/planets.material	(revision 8211)
+++ data/pool/materials/planets.material	(revision 8211)
@@ -0,0 +1,126 @@
+material planets/blueplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture blueplanet.png
+			}
+		}
+	}
+}
+
+material planets/brownplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture brownplanet.png
+			}
+		}
+	}
+}
+
+material planets/greenplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture greenplanet.png
+			}
+		}
+	}
+}
+
+material planets/greyplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture greyplanet.png
+			}
+		}
+	}
+}
+
+material planets/redplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture redplanet.png
+			}
+		}
+	}
+}
+
+material planets/violetplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture violetplanet.png
+			}
+		}
+	}
+}
+
+material planets/violetplanet
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture violetplanet.png
+			}
+		}
+	}
+}
+