Index: branches/bsp_model/src/lib/collision_detection/cd_engine.cc
===================================================================
--- branches/bsp_model/src/lib/collision_detection/cd_engine.cc	(revision 8217)
+++ branches/bsp_model/src/lib/collision_detection/cd_engine.cc	(revision 8218)
@@ -109,5 +109,5 @@
   for( bspIterator = bspList->begin(); bspIterator != bspList->end(); bspIterator++) {
       for(entityIterator = list1.begin(); entityIterator != list1.end(); entityIterator++)
-        (static_cast<BspEntity*>(*bspIterator)->getBspManager())->checkCollision(*entityIterator);
+        (dynamic_cast<BspEntity*>(*bspIterator)->getBspManager())->checkCollision(*entityIterator);
   }
 }
Index: branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc
===================================================================
--- branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc	(revision 8217)
+++ branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc	(revision 8218)
@@ -918,6 +918,6 @@
    if(collision)
      worldEntity->registerCollision(worldEntity, Vector(this->collPlane->x, this->collPlane->y, this->collPlane->z), out);
-
-}
+}
+
 
 void  BspManager::checkCollision(BspTreeNode* node, Vector* cam)
Index: branches/bsp_model/src/lib/graphics/importer/bsp_manager.h
===================================================================
--- branches/bsp_model/src/lib/graphics/importer/bsp_manager.h	(revision 8217)
+++ branches/bsp_model/src/lib/graphics/importer/bsp_manager.h	(revision 8218)
@@ -64,5 +64,5 @@
 
 
-  void checkCollision(WorldEntity* worldEntity); /*!< WorldEntities use this function to check wheter they collided with the BSPEntity.
+  void checkCollision(WorldEntity* worldEntity); /*!< WorldEntities use this function to check wheter they collided with the BspEntity.
                                                       If a collision has been detected, the collides-function of worldEntity will be called.*/
 
Index: branches/bsp_model/src/world_entities/bsp_entity.cc
===================================================================
--- branches/bsp_model/src/world_entities/bsp_entity.cc	(revision 8217)
+++ branches/bsp_model/src/world_entities/bsp_entity.cc	(revision 8218)
@@ -17,12 +17,12 @@
 #include "util/loading/resource_manager.h"
 
-CREATE_FACTORY(BSPEntity, CL_BSP_ENTITY);
+CREATE_FACTORY(BspEntity, CL_BSP_ENTITY);
 
 
 /**
- * constructs and loads a BSPEntity from a XML-element
+ * constructs and loads a BspEntity from a XML-element
  * @param root the XML-element to load from
  */
-BSPEntity::BSPEntity(const TiXmlElement* root)
+BspEntity::BspEntity(const TiXmlElement* root)
 {
   this->init();
@@ -35,10 +35,10 @@
  * standard deconstructor
  */
-BSPEntity::~BSPEntity ()
+BspEntity::~BspEntity ()
 {
 
 }
 
-void BSPEntity::setName(const std::string& name)
+void BspEntity::setName(const std::string& name)
 {
   printf("+++++++++++ LOADING NAME %s\n", name.c_str());
@@ -50,11 +50,11 @@
 
 /**
- * initializes the BSPEntity
+ * initializes the BspEntity
  * @todo change this to what you wish
  */
-void BSPEntity::init()
+void BspEntity::init()
 {
   this->bspManager = new BspManager();
-  this->setClassID(CL_BSP_ENTITY, "BSPEntity");
+  this->setClassID(CL_BSP_ENTITY, "BspEntity");
 
   this->toList(OM_ENVIRON);
@@ -68,14 +68,14 @@
 
 /**
- * loads a BSPEntity from a XML-element
+ * loads a BspEntity from a XML-element
  * @param root the XML-element to load from
  * @todo make the class Loadable
  */
-void BSPEntity::loadParams(const TiXmlElement* root)
+void BspEntity::loadParams(const TiXmlElement* root)
 {
   // all the clases this Entity is directly derived from must be called in this way, to load all settings.
  // WorldEntity::loadParam(root);
 
-  LoadParam(root, "Name", this, BSPEntity, setName)
+  LoadParam(root, "Name", this, BspEntity, setName)
       .describe("Sets the of the BSP file.");
 
@@ -91,8 +91,8 @@
 
 /**
- * advances the BSPEntity about time seconds
+ * advances the BspEntity about time seconds
  * @param time the Time to step
  */
-void BSPEntity::tick(float time)
+void BspEntity::tick(float time)
 {
   this->bspManager->tick(time);
@@ -103,5 +103,5 @@
  * draws this worldEntity
  */
-void BSPEntity::draw () const
+void BspEntity::draw () const
 {
   this->bspManager->draw();
@@ -113,5 +113,5 @@
  *
  */
-void BSPEntity::collidesWith (WorldEntity* entity, const Vector& location)
+void BspEntity::collidesWith (WorldEntity* entity, const Vector& location)
 {
 
Index: branches/bsp_model/src/world_entities/bsp_entity.h
===================================================================
--- branches/bsp_model/src/world_entities/bsp_entity.h	(revision 8217)
+++ branches/bsp_model/src/world_entities/bsp_entity.h	(revision 8218)
@@ -16,10 +16,10 @@
 
 //! A Class to ...
-class BSPEntity : public WorldEntity
+class BspEntity : public WorldEntity
 {
 
  public:
-  BSPEntity(const TiXmlElement* root = NULL);
-  virtual ~BSPEntity();
+  BspEntity(const TiXmlElement* root = NULL);
+  virtual ~BspEntity();
 
   virtual void loadParams(const TiXmlElement* root);